﻿using System;
using System.Data;
using System.Windows.Forms;
using System.Collections;
using System.Data.OleDb;

namespace acessoDados_TreeView
{
    public partial class Form1 : Form
    {
        private OleDbConnection conexaoBD;
        private string arquivoDados;
        private ArrayList tabelaArray;
        private ArrayList camposArray;

        public Form1()
        {
            InitializeComponent();
        }

            private void conexaoDados(string arquivoDadosBD)
            {
                //localiza o arquivo .mdb na pasta bin\Debug do projeto
                //arquivoDados = Application.StartupPath + @"\Northwind.mdb";
            
                //define a string de conexão usando o provedor Oledb
                string conexao = @"provider=microsoft.jet.oledb.4.0;Password="""";data source=" + arquivoDadosBD;

                try
                {
                    //Inicializa o objeto conexaoBD
                    conexaoBD = new OleDbConnection(conexao);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }

                preencherTreeView();
            }

        private void preencherTreeView()
        {
            tvDados.Nodes.Clear();
            // define o no raiz para o TreeView.
            tvDados.Nodes.Add("Database");
            tvDados.Nodes[0].ImageIndex = 0;
            tvDados.Nodes[0].SelectedImageIndex = 0;
            tvDados.Nodes[0].Tag = "RootDB";

            GetTabelas(conexaoBD);

            // inclui nó tabela
            for (int i = 0; i < tabelaArray.Count; i++)
            {
                tvDados.Nodes[0].Nodes.Add(tabelaArray[i].ToString());
                tvDados.Nodes[0].Nodes[i].Tag = "Tabelas";
                tvDados.Nodes[0].Nodes[i].ImageIndex = 2;
                tvDados.Nodes[0].Nodes[i].SelectedImageIndex = 2;
            }

            // inclui nó campo
            for (int i = 0; i < tabelaArray.Count; i++)
            {
                GetCampos(conexaoBD, tabelaArray[i].ToString());
                for (int j = 0; j < camposArray.Count; j++)
                {
                    tvDados.Nodes[0].Nodes[i].Nodes.Add(camposArray[j].ToString());
                    tvDados.Nodes[0].Nodes[i].Nodes[j].Tag = "Campos";
                    tvDados.Nodes[0].Nodes[i].Nodes[j].ImageIndex = 4;
                    tvDados.Nodes[0].Nodes[i].Nodes[j].SelectedImageIndex = 4;
                }
            }
        }

        private void GetTabelas(OleDbConnection conBD)
        {
            try
            {
                //abre a conexão
                conBD.Open();
                //obtem informações do esquema (nome das tabelas do banco de dados)
                DataTable schTable = conBD.GetOleDbSchemaTable(OleDbSchemaGuid.Tables,
                    new Object[] { null, null, null, "TABLE" });

                tabelaArray = new ArrayList();
                //preenche o array com  o nome das tabelas
                foreach (DataRow datRow in schTable.Rows)
                {
                    tabelaArray.Add(datRow["TABLE_NAME"].ToString());
                }
                conBD.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void GetCampos(OleDbConnection conBD, string tabNode)
        {
            string tabelaNome;
            try
            {
                tabelaNome = tabNode;
                //abre a conexão
                conBD.Open();
                //obtem informações do esquema (nome dos campos da tabela)
                DataTable schTable = conBD.GetOleDbSchemaTable(OleDbSchemaGuid.Columns,
                    new Object[] { null, null, tabelaNome });

                camposArray = new ArrayList();
                //preenche o array com o nome dos campos
                foreach (DataRow datRow in schTable.Rows)
                {
                    camposArray.Add(datRow["COLUMN_NAME"].ToString());
                }
                conBD.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void PreencherListView(OleDbConnection conBD, string nomeTabela)
        {
            OleDbCommand cmdBD;
            OleDbDataReader datReader;

            string strCampo;
            
            //define o nome da tabela
            txtTabela.Text = nomeTabela;
            
            //define uma instrução SQL para obter os dados da tabela
            strCampo = "SELECT * FROM [" + nomeTabela + "]";
            
            // Inicializa o objeto command
            cmdBD = new OleDbCommand(strCampo, conBD);
            //abre a conexão e executa o command
            conBD.Open();
            datReader = cmdBD.ExecuteReader();

            // Preenche o ListView
            while (datReader.Read())
            {
                ListViewItem objListItem = new ListViewItem(datReader.GetValue(0).ToString());
                for (int c = 1; c < datReader.FieldCount; c++)
                {
                    objListItem.SubItems.Add(datReader.GetValue(c).ToString());
                }
                objListItem.ImageIndex = 5;
                lvDados.Items.Add(objListItem);
            }
            //fecha o datareader e a conexao
            datReader.Close();
            conBD.Close();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // inicializa o TreeView
            tvDados.ImageList = imageList1;
            // inicializa o ListView
            lvDados.SmallImageList = imageList1;
            lvDados.Clear();
            lvDados.View = View.Details;
            lvDados.LabelEdit = false;
            lvDados.FullRowSelect = true;
            lvDados.GridLines = true;
        }

        private void tvDados_AfterExpand(object sender, TreeViewEventArgs e)
        {
            string tabelaNome;
            int contadorCampo;

            if (e.Node.Tag.ToString() == "RootDB")
            {
                e.Node.ImageIndex = 1;
                e.Node.SelectedImageIndex = 1;
            }
            else if (e.Node.Tag.ToString() == "Tabelas")
            {
                e.Node.ImageIndex = 3;
                e.Node.SelectedImageIndex = 3;
                contadorCampo = e.Node.GetNodeCount(false);
                // cria o cabeçalho das colunas.
                int n = lvDados.Width;
                double largura = n / contadorCampo; // largura a coluna
                for (int c = 0; c < contadorCampo; c++)
                {
                    lvDados.Columns.Add(e.Node.Nodes[c].Text, (int)largura, HorizontalAlignment.Left);
                }
                // pega o nome da tabela
                tabelaNome = e.Node.Text;
                PreencherListView(conexaoBD, tabelaNome);
            }

        }

        private void tvDados_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            lvDados.Clear();
            // expande somente um no
            for (int i = 0; i < tvDados.Nodes[0].GetNodeCount(false); i++)
            {
                tvDados.Nodes[0].Nodes[i].Collapse();
            }
        }

        private void tvDados_AfterCollapse(object sender, TreeViewEventArgs e)
        {
            if (e.Node.Tag.ToString() == "RootDB")
            {
                e.Node.ImageIndex = 0;
                e.Node.SelectedImageIndex = 0;
            }
            else if (e.Node.Tag.ToString() == "Tabelas")
            {
                e.Node.ImageIndex = 2;
                e.Node.SelectedImageIndex = 2;
                lvDados.Clear();
            }
        }

        private void btnSelecionaBD_Click(object sender, EventArgs e)
        { 
            arquivoDados = selecionaArquivoBD("c:\\dados\\");
            conexaoDados(arquivoDados);
            txtBancoDados.Text = arquivoDados;
        }

        private string selecionaArquivoBD(string pastaInicial)
        {
            //abre uma nova caixa de dialogo para selecionar arquivo
            OpenFileDialog dialog = new OpenFileDialog();
            //define alguns parâmetros
            dialog.Filter ="mdb files (*.mdb)|*.mdb|All files (*.*)|*.*";
            dialog.InitialDirectory = pastaInicial;
            dialog.Title = "Selecione um rquivo";
            //retorna o arquivo selecionado
            return (dialog.ShowDialog() == DialogResult.OK)? dialog.FileName : null;
        }

        private void SairMenuItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Deseja encerrar o programa ?", "Aplicação",MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                Application.Exit();
            }
        }
    }
}
